## mingw-w64-fontforge-20230101-8.src.tar.zst

=== Unicode/CMakeLists.txt ===
# Distributed under the original FontForge BSD 3-clause license

add_library(gunicode OBJECT
  ArabicForms.c
  char.c
  memory.c
  ucharmap.c
  unialt.c
  uninames.c
  ustring.c
  utype.c
)

if(BUILD_SHARED_LIBS)
  set_property(TARGET gunicode PROPERTY POSITION_INDEPENDENT_CODE ON)
endif()

if(${CMAKE_VERSION} VERSION_LESS "3.12.0")
  make_object_interface(gunicode
    fontforge_common_headers
    Iconv::Iconv
    Intl::Intl
  )
else()
  target_link_libraries(gunicode
    PUBLIC
      fontforge_common_headers
      Iconv::Iconv
      Intl::Intl
  )
endif()

target_compile_options(gunicode PRIVATE ${FONTFORGE_EXTRA_CFLAGS})

=== desktop/CMakeLists.txt ===
# Distributed under the original FontForge BSD 3-clause license

if(UNIX)
  install(FILES org.fontforge.FontForge.desktop DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)
  install(FILES fontforge.xml DESTINATION ${CMAKE_INSTALL_DATADIR}/mime/packages)

  foreach(_size 16x16 22x22 24x24 32x32 48x48 64x64 128x128 256x256 512x512)
    install(FILES "${THEME}/${_size}/org.fontforge.FontForge.png" DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/${_size}/apps)
  endforeach()
  install(FILES "${THEME}/scalable/org.fontforge.FontForge.svg" DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/apps)

  file(STRINGS "${PROJECT_SOURCE_DIR}/po/LINGUAS" _langs)
  foreach(_lang ${_langs})
    list(APPEND _pofiles "${PROJECT_SOURCE_DIR}/po/${_lang}.po")
  endforeach()

  macro(msgfmt_desktop_file _mode _file _installdir)
    set(_input "${CMAKE_CURRENT_SOURCE_DIR}/${_file}.in")
    set(_output "${CMAKE_CURRENT_BINARY_DIR}/${_file}")
    add_custom_command(OUTPUT "${_output}"
      COMMAND "${GETTEXT_MSGFMT_EXECUTABLE}"
        --${_mode} --template "${_input}"
        -d "${PROJECT_SOURCE_DIR}/po"
        -o "${_output}"
      DEPENDS "${_input}" ${_pofiles}
      VERBATIM
    )
    install(FILES "${_output}" DESTINATION "${_installdir}")
    list(APPEND _desktop_dependencies "${_output}")
  endmacro()

  # This would work, except there's a bug on msgfmt 0.19.7 which causes
  # desktop files to be mis-parsed if there's lines longer than 100 chars
  # msgfmt_desktop_file(desktop org.fontforge.FontForge.desktop "${CMAKE_INSTALL_DATADIR}/applications")

  msgfmt_desktop_file(xml org.fontforge.FontForge.appdata.xml "${CMAKE_INSTALL_DATADIR}/metainfo")

  add_custom_target(appstream ALL DEPENDS ${_desktop_dependencies})
endif()

=== gdraw/CMakeLists.txt ===
# Distributed under the original FontForge BSD 3-clause license

# not included
#  gdrawwacomdriver.c genkeysym.c growcol.c

add_library(gdraw STATIC
  choosericons.c
  colorP.h
  ctlvalues.c
  div_tables.c
  drawboxborder.c
  fontP.h
  gaskdlg.c
  gbuttons.c
  gcolor.c
  gcontainer.c
  gdrawable.c
  gdraw.c
  gdrawerror.c
  gdrawgimage.c
  gdrawP.h
  gdrawtxt.c
  gfilechooser.c
  gfiledlg.c
  gflowbox.c
  ggadgetP.h
  ggadgets.c
  ggdkcdraw.c
  ggdkdraw.c
  ggdkdrawlogger.c
  ggdkdrawP.h
  ggroupbox.c
  ghvbox.c
  gimageclut.c
  gimagecvt.c
  gimagexdraw.c
  gkeysym.c
  glist.c
  gmatrixedit.c
  gmenu.c
  gprogress.c
  gradio.c
  gresedit.c
  gresource.c
  gresourceP.h
  gsavefiledlg.c
  gscrollbar.c
  gscroll1box.c
  gspacer.c
  gtabset.c
  gtextfield.c
  gtextinfo.c
  gwidgetP.h
  gwidgets.c
  gxcdraw.c
  gxcdrawP.h
  gxdraw.c
  gxdrawP.h
  hotkeys.c
  xkeysyms_unicode.c
)

target_link_libraries(gdraw PRIVATE fontforge)

if(ENABLE_X11)
  target_link_libraries(gdraw PUBLIC
    X11::X11
    X11::Xi
    X11::Xkb
    Cairo::Cairo
    Pango::Pango
  )
else()
  if(APPLE)
    target_sources(gdraw PRIVATE ggdkcocoa.m)
  endif()
  target_link_libraries(gdraw PUBLIC GDK3::GDK3)
endif()

=== po/CMakeLists.txt ===
# Distributed under the original FontForge BSD 3-clause license

# * Run the 'pofiles' command to generate the binary .mo files
# * Run the 'potfiles' ocmmand to generate the master .pot file
#   (which contains all translatable strings)
# * Run the 'fullpo' command to generate the .po files, merged
#   with the master .pot file and with context

# TODO: Probably should add a FindXGettext or something
add_custom_target(potfiles
  COMMAND xgettext
    --from-code=utf-8
    -k_ -kN_ -kS_ -kU_ -kNU_ -kP_:1,2
    --sort-by-file
    --add-comments=GT:
    "-o${CMAKE_CURRENT_BINARY_DIR}/FontForge.pot"
    ../fontforge/*.c
    ../fontforgeexe/*.c
    ../gdraw/*.c
    ../gutils/*.c
    ../inc/*.h
    ../Unicode/*.c
    ../Unicode/*.h
    ../desktop/org.fontforge.FontForge.appdata.xml.in
    ../desktop/org.fontforge.FontForge.desktop
  COMMAND patch "${CMAKE_CURRENT_BINARY_DIR}/FontForge.pot" "pottitle.patch"
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
)

file(STRINGS LINGUAS _langs)

foreach(_lang ${_langs})
  set(_input "${CMAKE_CURRENT_SOURCE_DIR}/${_lang}.po")
  set(_output "${CMAKE_CURRENT_BINARY_DIR}/${_lang}.mo")
  set(_full "${CMAKE_CURRENT_BINARY_DIR}/full/${_lang}.po")
  add_custom_command(OUTPUT "${_output}"
    COMMAND "${GETTEXT_MSGFMT_EXECUTABLE}" --check -o "${_output}" "${_input}"
    DEPENDS "${_input}"
    VERBATIM
  )
  add_custom_command(OUTPUT "${_full}"
    COMMAND "${CMAKE_COMMAND}" -E make_directory "${CMAKE_CURRENT_BINARY_DIR}/full"
    COMMAND "${GETTEXT_MSGMERGE_EXECUTABLE}" -N "${_input}" -F "${CMAKE_CURRENT_BINARY_DIR}/FontForge.pot" -o "${_full}"
    DEPENDS "${_input}" potfiles
    VERBATIM
  )
  install(FILES "${_output}" DESTINATION "${CMAKE_INSTALL_LOCALEDIR}/${_lang}/LC_MESSAGES" RENAME "FontForge.mo" COMPONENT pofiles)
  list(APPEND _outputs "${_output}")
  list(APPEND _fulls "${_full}")
endforeach()

add_custom_target(pofiles ALL DEPENDS ${_outputs})
add_custom_target(fullpo DEPENDS ${_fulls})
add_custom_target(poupdate
  COMMAND "${Python3_EXECUTABLE}" "update.py" "${CMAKE_CURRENT_BINARY_DIR}/FontForge.pot"
  DEPENDS potfiles
  WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
  VERBATIM
)

if(ENABLE_MAINTAINER_TOOLS)
  add_executable(toengb toengb.c)
endif()

=== PKGBUILD ===
# Maintainer: Biswapriyo Nath <nathbappai@gmail.com>

_realname=fontforge
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=20230101
pkgrel=8
pkgdesc='Outline and bitmap font editor (mingw-w64)'
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://fontforge.org/'
msys2_repository_url="https://github.com/fontforge/fontforge"
msys2_references=(
  "cpe: cpe:/a:alexej_kryukov:fontforge"
  "cpe: cpe:/a:fontforge:fontforge"
)
license=('spdx:GPL-3.0-or-later')
depends=("${MINGW_PACKAGE_PREFIX}-cairo"
         "${MINGW_PACKAGE_PREFIX}-cc-libs"
         "${MINGW_PACKAGE_PREFIX}-freetype"
         "${MINGW_PACKAGE_PREFIX}-gettext-runtime"
         "${MINGW_PACKAGE_PREFIX}-giflib"
         "${MINGW_PACKAGE_PREFIX}-glib2"
         "${MINGW_PACKAGE_PREFIX}-gtk3"
         "${MINGW_PACKAGE_PREFIX}-libiconv"
         "${MINGW_PACKAGE_PREFIX}-libjpeg-turbo"
         "${MINGW_PACKAGE_PREFIX}-libpng"
         "${MINGW_PACKAGE_PREFIX}-libspiro"
         "${MINGW_PACKAGE_PREFIX}-libtiff"
         "${MINGW_PACKAGE_PREFIX}-libxml2"
         "${MINGW_PACKAGE_PREFIX}-pango"
         "${MINGW_PACKAGE_PREFIX}-python"
         "${MINGW_PACKAGE_PREFIX}-readline"
         "${MINGW_PACKAGE_PREFIX}-woff2"
         "${MINGW_PACKAGE_PREFIX}-zlib")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-gettext-tools"
             "${MINGW_PACKAGE_PREFIX}-python-sphinx")
source=("https://github.com/${_realname}/${_realname}/releases/download/${pkgver}/${_realname}-${pkgver}.tar.xz"
        "fontforge-doc-no-warn-error.patch"
        "001-no-distutils.patch"
        "002-update-po-files.patch"::https://github.com/fontforge/fontforge/commit/642d8a3db6d4bc0e70b429622fdf01ecb09c4c10.patch)
sha256sums=('ca82ec4c060c4dda70ace5478a41b5e7b95eb035fe1c4cf85c48f996d35c60f8'
            'b87fa5a39d6948262d2dfb9b84c2462dc21de0bfb115cdd13e893c1b533d8f78'
            '9903e4ff6f202cf588d71f23fd8c8a11b88ef9d9e796f8b41305bb27c87e50ea'
            'ca4e15fca23c14851e74ad2a3551cf8426e46cf6b0c093aab43bea346a656236')

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying $_patch"
    patch -Np1 -i "${srcdir}/$_patch"
  done
}

prepare() {
  cd "${srcdir}/${_realname}-${pkgver}"
  apply_patch_with_msg \
    fontforge-doc-no-warn-error.patch \
    001-no-distutils.patch \
    002-update-po-files.patch
}

build() {
  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake.exe \
    -G "Ninja" \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    "${_extra_config[@]}" \
    -DPython3_EXECUTABLE=${MINGW_PREFIX}/bin/python.exe \
    -DENABLE_MAINTAINER_TOOLS=ON \
    -DENABLE_FONTFORGE_EXTRAS=ON \
    "../${_realname}-${pkgver}"

  ${MINGW_PREFIX}/bin/cmake.exe --build ./
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake.exe --install ./

  install -Dm644 "${srcdir}/${_realname}-${pkgver}/LICENSE" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"
}
